> ## Documentation Index
> Fetch the complete documentation index at: https://doc.extole.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List all campaign controller actions

> Returns all actions configured on the specified campaign controller, across all action types.



## OpenAPI

````yaml /api-reference/management-expert.json get /v2/campaigns/{campaignId}{version}/controllers/{controllerId}/actions
openapi: 3.0.1
info:
  description: >-
    Advanced configuration endpoints for Extole platform experts: campaign
    controllers, typed actions and triggers, advanced component types and
    facets, source mapping, report post-handlers, pre-handlers, and other expert
    configuration surfaces not included in the standard Management API.
  title: Management Expert API
  version: '1.0'
servers:
  - description: Production
    url: https://api.extole.io
security:
  - HEADER: []
  - QUERY: []
  - COOKIE: []
tags:
  - name: Authentication
  - name: Campaign Controllers
  - name: Campaign Controllers Actions
  - name: Campaign Controllers Triggers
  - name: Campaign Flow Steps
  - name: Components
  - name: Components Grants
  - name: Components Subscriptions
  - name: Components Types
  - name: Content
  - name: Debug
  - name: Domains
  - name: Email
  - name: Event Prehandlers
  - name: Events
  - name: Javascript Core Extensions
  - name: Persons
  - name: Profiles
  - name: Report Schedules
  - name: Report Types
  - name: Reporting
  - name: Security Keys
  - name: Settings
paths:
  /v2/campaigns/{campaignId}{version}/controllers/{controllerId}/actions:
    get:
      tags:
        - Campaign Controllers Actions
      summary: List all campaign controller actions
      description: >-
        Returns all actions configured on the specified campaign controller,
        across all action types.
      operationId: listCampaignControllerActions
      parameters:
        - in: path
          name: campaignId
          required: true
          schema:
            type: string
        - in: path
          name: version
          required: true
          schema:
            pattern: (/version/.+)?
            type: string
        - in: path
          name: controllerId
          required: true
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/CampaignControllerActionResponse'
                type: array
          description: Successful response
        '400':
          content:
            application/json:
              examples:
                binding_error:
                  $ref: '#/components/examples/binding_error'
                campaign_concurrent_update:
                  $ref: '#/components/examples/campaign_concurrent_update'
                campaign_has_pending_changes:
                  $ref: '#/components/examples/campaign_has_pending_changes'
                campaign_locked:
                  $ref: '#/components/examples/campaign_locked'
                campaign_version_malformed:
                  $ref: '#/components/examples/campaign_version_malformed'
                date_invalid:
                  $ref: '#/components/examples/date_invalid'
                invalid_campaign_id:
                  $ref: '#/components/examples/invalid_campaign_id'
                invalid_campaign_state:
                  $ref: '#/components/examples/invalid_campaign_state'
                invalid_campaign_version:
                  $ref: '#/components/examples/invalid_campaign_version'
                invalid_json:
                  $ref: '#/components/examples/invalid_json'
                invalid_parameter:
                  $ref: '#/components/examples/invalid_parameter'
                lock_missing_lock_types:
                  $ref: '#/components/examples/lock_missing_lock_types'
                missing_request_body:
                  $ref: '#/components/examples/missing_request_body'
                unlock_missing_lock_types:
                  $ref: '#/components/examples/unlock_missing_lock_types'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Bad Request
        '401':
          content:
            application/json:
              examples:
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unauthorized
        '402':
          content:
            application/json:
              examples:
                payment_required:
                  $ref: '#/components/examples/payment_required'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Payment Required
        '403':
          content:
            application/json:
              examples:
                access_denied:
                  $ref: '#/components/examples/access_denied'
                invalid_campaign_controller_id:
                  $ref: '#/components/examples/invalid_campaign_controller_id'
                invalid_controller_action_id:
                  $ref: '#/components/examples/invalid_controller_action_id'
                invalid_controller_trigger_id:
                  $ref: '#/components/examples/invalid_controller_trigger_id'
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
                missing_access_token:
                  $ref: '#/components/examples/missing_access_token'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Forbidden
        '415':
          content:
            application/json:
              examples:
                unsupported_media_type:
                  $ref: '#/components/examples/unsupported_media_type'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unsupported Media Type
        '429':
          content:
            application/json:
              examples:
                too_many_requests:
                  $ref: '#/components/examples/too_many_requests'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Too Many Requests
components:
  schemas:
    CampaignControllerActionResponse:
      description: >-
        Stored campaign controller action definition. Field `enabled` is
        unevaluated and appears in buildtime-evaluatable form.
      discriminator:
        mapping:
          APPROVE:
            $ref: '#/components/schemas/CampaignControllerActionApproveResponse'
          CANCEL_REWARD:
            $ref: '#/components/schemas/CampaignControllerActionCancelRewardResponse'
          CREATE_MEMBERSHIP:
            $ref: >-
              #/components/schemas/CampaignControllerActionCreateMembershipResponse
          CREATIVE:
            $ref: '#/components/schemas/CampaignControllerActionCreativeResponse'
          DATA_INTELLIGENCE:
            $ref: >-
              #/components/schemas/CampaignControllerActionDataIntelligenceResponse
          DECLINE:
            $ref: '#/components/schemas/CampaignControllerActionDeclineResponse'
          DISPLAY:
            $ref: '#/components/schemas/CampaignControllerActionDisplayResponse'
          EARN_REWARD:
            $ref: '#/components/schemas/CampaignControllerActionEarnRewardResponse'
          EMAIL:
            $ref: '#/components/schemas/CampaignControllerActionEmailResponse'
          EXPRESSION:
            $ref: '#/components/schemas/CampaignControllerActionExpressionResponse'
          FIRE_AS_PERSON:
            $ref: '#/components/schemas/CampaignControllerActionFireAsPersonResponse'
          FULFILL_REWARD:
            $ref: '#/components/schemas/CampaignControllerActionFulfillRewardResponse'
          INCENTIVIZE:
            $ref: '#/components/schemas/CampaignControllerActionIncentivizeResponse'
          INCENTIVIZE_STATUS_UPDATE:
            $ref: >-
              #/components/schemas/CampaignControllerActionIncentivizeStatusUpdateResponse
          REDEEM_REWARD:
            $ref: '#/components/schemas/CampaignControllerActionRedeemRewardResponse'
          REMOVE_MEMBERSHIP:
            $ref: >-
              #/components/schemas/CampaignControllerActionRemoveMembershipResponse
          REVOKE_REWARD:
            $ref: '#/components/schemas/CampaignControllerActionRevokeRewardResponse'
          SCHEDULE:
            $ref: '#/components/schemas/CampaignControllerActionScheduleResponse'
          SHARE_EVENT:
            $ref: '#/components/schemas/CampaignControllerActionShareEventResponse'
          SIGNAL:
            $ref: '#/components/schemas/CampaignControllerActionSignalResponse'
          SIGNAL_V1:
            $ref: '#/components/schemas/CampaignControllerActionSignalV1Response'
          STEP_SIGNAL:
            $ref: '#/components/schemas/CampaignControllerActionStepSignalResponse'
          WEBHOOK:
            $ref: '#/components/schemas/CampaignControllerActionWebhookResponse'
        propertyName: action_type
      oneOf:
        - title: APPROVE
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionApproveResponse'
        - title: CANCEL_REWARD
          allOf:
            - $ref: >-
                #/components/schemas/CampaignControllerActionCancelRewardResponse
        - title: CREATE_MEMBERSHIP
          allOf:
            - $ref: >-
                #/components/schemas/CampaignControllerActionCreateMembershipResponse
        - title: CREATIVE
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionCreativeResponse'
        - title: DATA_INTELLIGENCE
          allOf:
            - $ref: >-
                #/components/schemas/CampaignControllerActionDataIntelligenceResponse
        - title: DECLINE
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionDeclineResponse'
        - title: DISPLAY
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionDisplayResponse'
        - title: EARN_REWARD
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionEarnRewardResponse'
        - title: EMAIL
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionEmailResponse'
        - title: EXPRESSION
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionExpressionResponse'
        - title: FIRE_AS_PERSON
          allOf:
            - $ref: >-
                #/components/schemas/CampaignControllerActionFireAsPersonResponse
        - title: FULFILL_REWARD
          allOf:
            - $ref: >-
                #/components/schemas/CampaignControllerActionFulfillRewardResponse
        - title: INCENTIVIZE
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionIncentivizeResponse'
        - title: INCENTIVIZE_STATUS_UPDATE
          allOf:
            - $ref: >-
                #/components/schemas/CampaignControllerActionIncentivizeStatusUpdateResponse
        - title: REDEEM_REWARD
          allOf:
            - $ref: >-
                #/components/schemas/CampaignControllerActionRedeemRewardResponse
        - title: REMOVE_MEMBERSHIP
          allOf:
            - $ref: >-
                #/components/schemas/CampaignControllerActionRemoveMembershipResponse
        - title: REVOKE_REWARD
          allOf:
            - $ref: >-
                #/components/schemas/CampaignControllerActionRevokeRewardResponse
        - title: SCHEDULE
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionScheduleResponse'
        - title: SHARE_EVENT
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionShareEventResponse'
        - title: SIGNAL
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionSignalResponse'
        - title: SIGNAL_V1
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionSignalV1Response'
        - title: STEP_SIGNAL
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionStepSignalResponse'
        - title: WEBHOOK
          allOf:
            - $ref: '#/components/schemas/CampaignControllerActionWebhookResponse'
      required:
        - action_id
        - action_type
        - component_ids
        - component_references
        - enabled
        - quality
    RestExceptionResponse:
      description: Represents the API error response
      properties:
        code:
          description: Specific error code for this error type, documented per endpoint
          type: string
        http_status_code:
          description: >-
            HTTP status code that was returned with this error, useful if client
            get response code
          format: int32
          type: integer
        message:
          description: User readable English description of the error
          type: string
        parameters:
          additionalProperties:
            description: >-
              Attributes related to the error, varies be error code, documented
              per endpoint
            type: object
          description: >-
            Attributes related to the error, varies be error code, documented
            per endpoint
          type: object
        unique_id:
          description: >-
            Unique id associated with this error, useful for discussions with
            Extole
          type: string
      required:
        - code
        - http_status_code
        - message
        - parameters
        - unique_id
      type: object
    CampaignControllerActionApproveResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - APPROVE
              type: string
            cause_type:
              type: string
            event_type:
              type: string
            force:
              type: string
            legacy_action_id:
              type: string
            note:
              type: string
            partner_event_id:
              type: string
            polling_id:
              type: string
            polling_name:
              type: string
            reward_tags:
              $ref: >-
                #/components/schemas/RewardTagsInCampaignControllerActionApproveResponse
          type: object
      type: object
      title: APPROVE
    CampaignControllerActionCancelRewardResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - CANCEL_REWARD
              type: string
            message:
              type: string
            reward_id:
              type: string
          type: object
      type: object
      title: CANCEL_REWARD
    CampaignControllerActionCreateMembershipResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - CREATE_MEMBERSHIP
              type: string
            audience_id:
              $ref: >-
                #/components/schemas/AudienceIdInCampaignControllerActionCreateMembershipResponse
          type: object
      type: object
      title: CREATE_MEMBERSHIP
    CampaignControllerActionCreativeResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - CREATIVE
              type: string
            api_version:
              format: int32
              type: integer
            classification:
              enum:
                - EMAIL
                - JAVASCRIPT
                - PAGE
              type: string
            has_creative:
              type: boolean
            latest_version:
              format: int32
              type: integer
            output:
              additionalProperties:
                items:
                  type: string
                type: array
              type: object
            theme_version:
              type: string
          type: object
      type: object
      title: CREATIVE
    CampaignControllerActionDataIntelligenceResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - DATA_INTELLIGENCE
              type: string
            event_name:
              $ref: >-
                #/components/schemas/EventNameInCampaignControllerActionDataIntelligenceResponse
            intelligence_provider:
              $ref: >-
                #/components/schemas/IntelligenceProviderInCampaignControllerActionDataIntelligenceResponse
            profile_risk_update_interval:
              $ref: >-
                #/components/schemas/ProfileRiskUpdateIntervalInCampaignControllerActionDataIntelligenceResponse
          type: object
      type: object
      title: DATA_INTELLIGENCE
    CampaignControllerActionDeclineResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - DECLINE
              type: string
            cause_type:
              type: string
            event_type:
              type: string
            legacy_action_id:
              type: string
            note:
              type: string
            partner_event_id:
              type: string
            polling_id:
              type: string
            polling_name:
              type: string
          type: object
      type: object
      title: DECLINE
    CampaignControllerActionDisplayResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - DISPLAY
              type: string
            body:
              $ref: >-
                #/components/schemas/BodyInCampaignControllerActionDisplayResponse
            headers:
              $ref: >-
                #/components/schemas/HeadersInCampaignControllerActionDisplayResponse
            response:
              $ref: >-
                #/components/schemas/ResponseInCampaignControllerActionDisplayResponse
          type: object
      type: object
      title: DISPLAY
    CampaignControllerActionEarnRewardResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - EARN_REWARD
              type: string
            data:
              $ref: >-
                #/components/schemas/DataMapInCampaignControllerActionEarnRewardResponse
            event_time:
              $ref: >-
                #/components/schemas/EventTimeInCampaignControllerActionEarnRewardResponse
            extra_data:
              $ref: >-
                #/components/schemas/ExtraDataInCampaignControllerActionEarnRewardResponse
            reward_action_id:
              $ref: >-
                #/components/schemas/RewardActionIdInCampaignControllerActionEarnRewardResponse
            reward_name:
              $ref: >-
                #/components/schemas/RewardNameInCampaignControllerActionEarnRewardResponse
            reward_supplier_id:
              $ref: >-
                #/components/schemas/RewardSupplierIdInCampaignControllerActionEarnRewardResponse
            slots:
              $ref: >-
                #/components/schemas/SlotsInCampaignControllerActionEarnRewardResponse
            tags:
              $ref: >-
                #/components/schemas/TagsInCampaignControllerActionEarnRewardResponse
            value_of_event_being_rewarded:
              $ref: >-
                #/components/schemas/ValueOfEventBeingRewardedInCampaignControllerActionEarnRewardResponse
          type: object
      type: object
      title: EARN_REWARD
    CampaignControllerActionEmailResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - EMAIL
              type: string
            data:
              $ref: >-
                #/components/schemas/DataMapInCampaignControllerActionEmailResponse
            zone_name:
              $ref: >-
                #/components/schemas/ZoneNameInCampaignControllerActionEmailResponse
          type: object
      type: object
      title: EMAIL
    CampaignControllerActionExpressionResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - EXPRESSION
              type: string
            data:
              $ref: >-
                #/components/schemas/DataMapInCampaignControllerActionExpressionResponse
            expression:
              $ref: >-
                #/components/schemas/ExpressionInCampaignControllerActionExpressionResponse
          type: object
      type: object
      title: EXPRESSION
    CampaignControllerActionFireAsPersonResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - FIRE_AS_PERSON
              type: string
            as_person_identification:
              $ref: '#/components/schemas/FireAsPersonIdentification'
            as_person_journey:
              $ref: '#/components/schemas/FireAsPersonJourney'
            data:
              $ref: >-
                #/components/schemas/DataMapInCampaignControllerActionFireAsPersonResponse
            event_name:
              $ref: >-
                #/components/schemas/EventNameInCampaignControllerActionFireAsPersonResponse
            event_time:
              $ref: >-
                #/components/schemas/EventTimeInCampaignControllerActionFireAsPersonResponse
            extra_data:
              $ref: >-
                #/components/schemas/ExtraDataInCampaignControllerActionFireAsPersonResponse
            labels:
              items:
                type: string
              type: array
              uniqueItems: true
            person_id:
              $ref: >-
                #/components/schemas/PersonIdInCampaignControllerActionFireAsPersonResponse
          type: object
      type: object
      title: FIRE_AS_PERSON
    CampaignControllerActionFulfillRewardResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - FULFILL_REWARD
              type: string
            event_time:
              $ref: >-
                #/components/schemas/EventTimeInCampaignControllerActionFulfillRewardResponse
            message:
              type: string
            partner_reward_id:
              $ref: >-
                #/components/schemas/PartnerRewardIdInCampaignControllerActionFulfillRewardResponse
            reward_id:
              type: string
            success:
              type: string
          type: object
      type: object
      title: FULFILL_REWARD
    CampaignControllerActionIncentivizeResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_name:
              type: string
            action_type:
              enum:
                - INCENTIVIZE
              type: string
            data:
              $ref: >-
                #/components/schemas/DataMapInCampaignControllerActionIncentivizeResponse
            incentivize_action_type:
              $ref: >-
                #/components/schemas/IncentivizeActionTypeInCampaignControllerActionIncentivizeResponse
            overrides:
              additionalProperties:
                type: string
              type: object
            review_status:
              $ref: >-
                #/components/schemas/ReviewStatusInCampaignControllerActionIncentivizeResponse
          type: object
      type: object
      title: INCENTIVIZE
    CampaignControllerActionIncentivizeStatusUpdateResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - INCENTIVIZE_STATUS_UPDATE
              type: string
            data:
              $ref: >-
                #/components/schemas/DataMapInCampaignControllerActionIncentivizeStatusUpdateResponse
            event_type:
              $ref: >-
                #/components/schemas/EventTypeInCampaignControllerActionIncentivizeStatusUpdateResponse
            legacy_action_id:
              $ref: >-
                #/components/schemas/LegacyActionIdInCampaignControllerActionIncentivizeStatusUpdateResponse
            message:
              $ref: >-
                #/components/schemas/MessageInCampaignControllerActionIncentivizeStatusUpdateResponse
            move_to_pending:
              $ref: >-
                #/components/schemas/MoveToPendingInCampaignControllerActionIncentivizeStatusUpdateResponse
            partner_event_id:
              $ref: >-
                #/components/schemas/PartnerEventIdInCampaignControllerActionIncentivizeStatusUpdateResponse
            review_status:
              $ref: >-
                #/components/schemas/ReviewStatusInCampaignControllerActionIncentivizeStatusUpdateResponse
          type: object
      type: object
      title: INCENTIVIZE_STATUS_UPDATE
    CampaignControllerActionRedeemRewardResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - REDEEM_REWARD
              type: string
            data:
              additionalProperties:
                type: string
              type: object
            event_time:
              $ref: >-
                #/components/schemas/EventTimeInCampaignControllerActionRedeemRewardResponse
            partner_event_id:
              type: string
            reward_id:
              type: string
          type: object
      type: object
      title: REDEEM_REWARD
    CampaignControllerActionRemoveMembershipResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - REMOVE_MEMBERSHIP
              type: string
            audience_id:
              $ref: >-
                #/components/schemas/AudienceIdInCampaignControllerActionRemoveMembershipResponse
          type: object
      type: object
      title: REMOVE_MEMBERSHIP
    CampaignControllerActionRevokeRewardResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - REVOKE_REWARD
              type: string
            message:
              type: string
            reward_id:
              type: string
          type: object
      type: object
      title: REVOKE_REWARD
    CampaignControllerActionScheduleResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - SCHEDULE
              type: string
            data:
              $ref: >-
                #/components/schemas/DataMapInCampaignControllerActionScheduleResponse
            dates:
              $ref: >-
                #/components/schemas/DatesInCampaignControllerActionScheduleResponse
            delays:
              $ref: >-
                #/components/schemas/DelaysInCampaignControllerActionScheduleResponse
            extra_data:
              $ref: >-
                #/components/schemas/ExtraDataInCampaignControllerActionScheduleResponse
            force:
              type: boolean
            schedule_name:
              $ref: >-
                #/components/schemas/ScheduleNameInCampaignControllerActionScheduleResponse
          type: object
      type: object
      title: SCHEDULE
    CampaignControllerActionShareEventResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - SHARE_EVENT
              type: string
          type: object
      type: object
      title: SHARE_EVENT
    CampaignControllerActionSignalResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - SIGNAL
              type: string
            data:
              $ref: >-
                #/components/schemas/DataMapInCampaignControllerActionSignalResponse
            name:
              $ref: >-
                #/components/schemas/NameInCampaignControllerActionSignalResponse
            signal_polling_id:
              $ref: >-
                #/components/schemas/SignalPollingIdInCampaignControllerActionSignalResponse
          type: object
      type: object
      title: SIGNAL
    CampaignControllerActionSignalV1Response:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - SIGNAL_V1
              type: string
            data:
              additionalProperties:
                type: string
              type: object
            signal_polling_id:
              type: string
          type: object
      type: object
      title: SIGNAL_V1
    CampaignControllerActionStepSignalResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - STEP_SIGNAL
              type: string
            name:
              type: string
            polling_id:
              type: string
          type: object
      type: object
      title: STEP_SIGNAL
    CampaignControllerActionWebhookResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignControllerActionResponseBase'
        - properties:
            action_type:
              enum:
                - WEBHOOK
              type: string
            data:
              $ref: >-
                #/components/schemas/DataMapInCampaignControllerActionWebhookResponse
            webhook_id:
              $ref: >-
                #/components/schemas/WebhookIdInCampaignControllerActionWebhookResponse
          type: object
      type: object
      title: WEBHOOK
    CampaignControllerActionResponseBase:
      properties:
        action_id:
          type: string
        action_type:
          enum:
            - APPROVE
            - CANCEL_REWARD
            - CREATE_MEMBERSHIP
            - CREATIVE
            - DATA_INTELLIGENCE
            - DECLINE
            - DISPLAY
            - EARN_REWARD
            - EMAIL
            - EXPRESSION
            - FIRE_AS_PERSON
            - FULFILL_REWARD
            - INCENTIVIZE
            - INCENTIVIZE_STATUS_UPDATE
            - REDEEM_REWARD
            - REMOVE_MEMBERSHIP
            - REVOKE_REWARD
            - SCHEDULE
            - SHARE_EVENT
            - SIGNAL
            - SIGNAL_V1
            - STEP_SIGNAL
            - WEBHOOK
          type: string
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        enabled:
          $ref: '#/components/schemas/EnabledInCampaignControllerActionResponseBase'
        quality:
          enum:
            - ALWAYS
            - HIGH
            - LOW
          type: string
      type: object
    RewardTagsInCampaignControllerActionApproveResponse:
      description: >-
        The reward tags as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal reward tags
          items:
            type: string
          title: Static Value
          type: array
          uniqueItems: true
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{rewardTags}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('rewardTags');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [ApproveActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/approve/ApproveActionContext.d.ts).
          example: handlebars@runtime:{{rewardTags}}
          externalDocs:
            description: ApproveActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/approve/ApproveActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ApproveActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/approve/ApproveActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('rewardTags');}
          externalDocs:
            description: ApproveActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/approve/ApproveActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    AudienceIdInCampaignControllerActionCreateMembershipResponse:
      description: >-
        The audience id as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal audience id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{audienceId}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('audienceId');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    EventNameInCampaignControllerActionDataIntelligenceResponse:
      description: >-
        The event name as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal event name
          title: Static Value
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{eventName}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('eventName');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    IntelligenceProviderInCampaignControllerActionDataIntelligenceResponse:
      description: >-
        The intelligence provider as configured: a literal value, or an
        expression (type:string) when defined dynamically.
      oneOf:
        - description: Literal intelligence provider
          enum:
            - EMAIL_AGE
            - MAXMIND
            - NOOP
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{intelligenceProvider}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('intelligenceProvider');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    ProfileRiskUpdateIntervalInCampaignControllerActionDataIntelligenceResponse:
      description: >-
        The profile risk update interval as configured: a literal value, or an
        expression (type:string) when defined dynamically.
      oneOf:
        - description: Literal profile risk update interval
          properties:
            nano:
              format: int32
              type: integer
            negative:
              type: boolean
            positive:
              type: boolean
            seconds:
              format: int64
              type: integer
            units:
              items:
                properties:
                  dateBased:
                    type: boolean
                  duration:
                    $ref: '#/components/schemas/Duration'
                  durationEstimated:
                    type: boolean
                  timeBased:
                    type: boolean
                type: object
              type: array
            zero:
              type: boolean
          title: Static Value
          type: object
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{profileRiskUpdateInterval}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('profileRiskUpdateInterval');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    BodyInCampaignControllerActionDisplayResponse:
      description: >-
        The body as configured: a literal value, or an expression (type:string)
        when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
                  - pattern: ^handlebars@runtime:.*
                    type: string
                  - pattern: ^javascript@runtime:.*
                    type: string
              type: string
          description: Literal body
          title: Static Value
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{body}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('body');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [DisplayActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionContext.d.ts).
          example: handlebars@runtime:{{body}}
          externalDocs:
            description: DisplayActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [DisplayActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('body');}
          externalDocs:
            description: DisplayActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    HeadersInCampaignControllerActionDisplayResponse:
      description: >-
        The headers as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - additionalProperties:
            type: string
          description: Literal headers
          title: Static Value
          type: object
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{headers}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('headers');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [DisplayActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionContext.d.ts).
          example: handlebars@runtime:{{headers}}
          externalDocs:
            description: DisplayActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [DisplayActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('headers');}
          externalDocs:
            description: DisplayActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    ResponseInCampaignControllerActionDisplayResponse:
      description: >-
        The response as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/ApiResponse'
          description: Literal response
          title: Static Value
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{response}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('response');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [DisplayActionResponseContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionResponseContext.d.ts).
          example: handlebars@runtime:{{response}}
          externalDocs:
            description: DisplayActionResponseContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionResponseContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [DisplayActionResponseContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionResponseContext.d.ts).
          example: javascript@runtime:function() { return context.get('response');}
          externalDocs:
            description: DisplayActionResponseContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/display/DisplayActionResponseContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    DataMapInCampaignControllerActionEarnRewardResponse:
      additionalProperties:
        $ref: '#/components/schemas/DataInCampaignControllerActionEarnRewardResponse'
      type: object
    EventTimeInCampaignControllerActionEarnRewardResponse:
      description: >-
        The event time as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/Instant'
          description: Literal event time
          title: Static Value
        - description: >-
            Handlebars expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: handlebars@runtime:{{eventTime}}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('eventTime');}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    ExtraDataInCampaignControllerActionEarnRewardResponse:
      description: >-
        The extra data as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - additionalProperties:
            type: object
          description: Literal extra data
          title: Static Value
          type: object
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{extraData}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('extraData');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: handlebars@runtime:{{extraData}}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('extraData');}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    RewardActionIdInCampaignControllerActionEarnRewardResponse:
      description: >-
        The reward action id as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal reward action id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: handlebars@runtime:{{rewardActionId}}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: >-
            javascript@runtime:function() { return
            context.get('rewardActionId');}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    RewardNameInCampaignControllerActionEarnRewardResponse:
      description: >-
        The reward name as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal reward name
          title: Static Value
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{rewardName}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('rewardName');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    RewardSupplierIdInCampaignControllerActionEarnRewardResponse:
      description: >-
        The reward supplier id as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal reward supplier id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{rewardSupplierId}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('rewardSupplierId');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    SlotsInCampaignControllerActionEarnRewardResponse:
      description: >-
        The slots as configured: a literal value, or an expression (type:string)
        when defined dynamically.
      oneOf:
        - description: Literal slots
          items:
            type: string
          title: Static Value
          type: array
          uniqueItems: true
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{slots}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('slots');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: handlebars@runtime:{{slots}}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('slots');}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    TagsInCampaignControllerActionEarnRewardResponse:
      description: >-
        The tags as configured: a literal value, or an expression (type:string)
        when defined dynamically.
      oneOf:
        - description: Literal tags
          items:
            type: string
          title: Static Value
          type: array
          uniqueItems: true
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{tags}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('tags');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: handlebars@runtime:{{tags}}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('tags');}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    ValueOfEventBeingRewardedInCampaignControllerActionEarnRewardResponse:
      description: >-
        The value of event being rewarded as configured: a literal value, or an
        expression (type:string) when defined dynamically.
      oneOf:
        - description: Literal value of event being rewarded
          title: Static Value
          type: object
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{valueOfEventBeingRewarded}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('valueOfEventBeingRewarded');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: handlebars@runtime:{{valueOfEventBeingRewarded}}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: >-
            javascript@runtime:function() { return
            context.get('valueOfEventBeingRewarded');}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    DataMapInCampaignControllerActionEmailResponse:
      additionalProperties:
        $ref: '#/components/schemas/DataInCampaignControllerActionEmailResponse'
      type: object
    ZoneNameInCampaignControllerActionEmailResponse:
      description: >-
        The zone name as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal zone name
          title: Static Value
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{zoneName}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('zoneName');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    DataMapInCampaignControllerActionExpressionResponse:
      additionalProperties:
        $ref: '#/components/schemas/DataInCampaignControllerActionExpressionResponse'
      type: object
    ExpressionInCampaignControllerActionExpressionResponse:
      description: >-
        The expression as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal expression
          title: Static Value
          type: object
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{expression}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('expression');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [ExpressionActionCommandContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/expression/ExpressionActionCommandContext.d.ts).
          example: handlebars@runtime:{{expression}}
          externalDocs:
            description: ExpressionActionCommandContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/expression/ExpressionActionCommandContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ExpressionActionCommandContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/expression/ExpressionActionCommandContext.d.ts).
          example: javascript@runtime:function() { return context.get('expression');}
          externalDocs:
            description: ExpressionActionCommandContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/expression/ExpressionActionCommandContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    FireAsPersonIdentification:
      discriminator:
        mapping:
          EMAIL:
            $ref: '#/components/schemas/EmailFireAsPersonIdentification'
          PARTNER_EVENT_ID:
            $ref: '#/components/schemas/PartnerEventIdFireAsPersonIdentification'
          PARTNER_USER_ID:
            $ref: '#/components/schemas/PartnerUserIdFireAsPersonIdentification'
          PERSON_ID:
            $ref: '#/components/schemas/PersonIdFireAsPersonIdentification'
        propertyName: person_identification_type
      oneOf:
        - title: EMAIL
          allOf:
            - $ref: '#/components/schemas/EmailFireAsPersonIdentification'
        - title: PARTNER_EVENT_ID
          allOf:
            - $ref: '#/components/schemas/PartnerEventIdFireAsPersonIdentification'
        - title: PARTNER_USER_ID
          allOf:
            - $ref: '#/components/schemas/PartnerUserIdFireAsPersonIdentification'
        - title: PERSON_ID
          allOf:
            - $ref: '#/components/schemas/PersonIdFireAsPersonIdentification'
    FireAsPersonJourney:
      properties:
        advocate_code:
          type: string
        advocate_partner_user_id:
          type: string
        campaign_id:
          type: string
        container:
          type: string
        coupon_code:
          type: string
        journey_type:
          type: string
        label:
          type: string
        promotable_code:
          type: string
        reason:
          type: string
        referral_reason:
          enum:
            - ADVOCATE
            - ADVOCATE_CODE
            - ADVOCATE_PARTNER_USER_ID
            - COUPON_CODE
            - DISPLACED_PARTNER_USER_ID
            - INCENTIVIZED_SHARE
            - PARTNER_EVENT_ID
            - PARTNER_SHARE_ID
            - SHAREABLE_ID
            - SHARE_ID
            - SHARE_RECIPIENT
            - UNKNOWN_REASON
          type: string
        share_id:
          type: string
        shareable_id:
          type: string
        zone:
          type: string
      type: object
    DataMapInCampaignControllerActionFireAsPersonResponse:
      additionalProperties:
        $ref: >-
          #/components/schemas/DataInCampaignControllerActionFireAsPersonResponse
      type: object
    EventNameInCampaignControllerActionFireAsPersonResponse:
      description: >-
        The event name as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal event name
          title: Static Value
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{eventName}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('eventName');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    EventTimeInCampaignControllerActionFireAsPersonResponse:
      description: >-
        The event time as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/ZonedDateTime'
          description: Literal event time
          title: Static Value
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{eventTime}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('eventTime');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [FireAsPersonActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts).
          example: handlebars@runtime:{{eventTime}}
          externalDocs:
            description: FireAsPersonActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [FireAsPersonActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('eventTime');}
          externalDocs:
            description: FireAsPersonActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    ExtraDataInCampaignControllerActionFireAsPersonResponse:
      description: >-
        The extra data as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - additionalProperties:
            type: object
          description: Literal extra data
          title: Static Value
          type: object
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{extraData}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('extraData');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [FireAsPersonActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts).
          example: handlebars@runtime:{{extraData}}
          externalDocs:
            description: FireAsPersonActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [FireAsPersonActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('extraData');}
          externalDocs:
            description: FireAsPersonActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    PersonIdInCampaignControllerActionFireAsPersonResponse:
      description: >-
        The person id as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal person id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{personId}}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ControllerBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('personId');}
          externalDocs:
            description: ControllerBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/ControllerBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [FireAsPersonActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts).
          example: handlebars@runtime:{{personId}}
          externalDocs:
            description: FireAsPersonActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [FireAsPersonActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('personId');}
          externalDocs:
            description: FireAsPersonActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/fire/as/person/FireAsPersonActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    EventTimeInCampaignControllerActionFulfillRewardResponse:
      description: >-
        The event time as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/Instant'
          description: Literal event time
          title: Static Value
        - description: >-
            Handlebars expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: handlebars@runtime:{{eventTime}}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: javascript@runtime:function() { return context.get('eventTime');}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    PartnerRewardIdInCampaignControllerActionFulfillRewardResponse:
      description: >-
        The partner reward id as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal partner reward id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: handlebars@runtime:{{partnerRewardId}}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [RewardActionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts).
          example: >-
            javascript@runtime:function() { return
            context.get('partnerRewardId');}
          externalDocs:
            description: RewardActionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/step/action/reward/RewardActionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    DataMapInCampaignControllerActionIncentivizeResponse:
      additionalProperties:
        $ref: '#/components/schemas/DataInCampaignControllerActionIncentivizeResponse'
      type: object
    IncentivizeActionTypeInCampaignControllerActionIncentivizeResponse:
      description: >-
        The incentivize action type as configured: a literal value, or an
        expression (type:string) when defined dynamically.
      oneOf:
        - description: Literal incentivize action type
          enum:
            - CLICK
            - GENERIC_ACTION_1
            - GENERIC_ACTION_10
            - GENERIC_ACTION_100
            - GENERIC_ACTION_101
            - GENERIC_ACTION_102
            - GENERIC_ACTION_103
            - GENERIC_ACTION_104
            - GENERIC_ACTION_105
            - GENERIC_ACTION_106
            - GENERIC_ACTION_107
            - GENERIC_ACTION_108
            - GENERIC_ACTION_109
            - GENERIC_ACTION_11
            - GENERIC_ACTION_110
            - GENERIC_ACTION_111
            - GENERIC_ACTION_112
            - GENERIC_ACTION_113
            - GENERIC_ACTION_114
            - GENERIC_ACTION_115
            - GENERIC_ACTION_116
            - GENERIC_ACTION_117
            - GENERIC_ACTION_118
            - GENERIC_ACTION_119
            - GENERIC_ACTION_12
            - GENERIC_ACTION_120
            - GENERIC_ACTION_121
            - GENERIC_ACTION_122
            - GENERIC_ACTION_123
            - GENERIC_ACTION_124
            - GENERIC_ACTION_125
            - GENERIC_ACTION_126
            - GENERIC_ACTION_127
            - GENERIC_ACTION_128
            - GENERIC_ACTION_129
            - GENERIC_ACTION_13
            - GENERIC_ACTION_130
            - GENERIC_ACTION_131
            - GENERIC_ACTION_132
            - GENERIC_ACTION_133
            - GENERIC_ACTION_134
            - GENERIC_ACTION_135
            - GENERIC_ACTION_136
            - GENERIC_ACTION_137
            - GENERIC_ACTION_138
            - GENERIC_ACTION_139
            - GENERIC_ACTION_14
            - GENERIC_ACTION_140
            - GENERIC_ACTION_141
            - GENERIC_ACTION_142
            - GENERIC_ACTION_143
            - GENERIC_ACTION_144
            - GENERIC_ACTION_145
            - GENERIC_ACTION_146
            - GENERIC_ACTION_147
            - GENERIC_ACTION_148
            - GENERIC_ACTION_149
            - GENERIC_ACTION_15
            - GENERIC_ACTION_150
            - GENERIC_ACTION_151
            - GENERIC_ACTION_152
            - GENERIC_ACTION_153
            - GENERIC_ACTION_154
            - GENERIC_ACTION_155
            - GENERIC_ACTION_156
            - GENERIC_ACTION_157
            - GENERIC_ACTION_158
            - GENERIC_ACTION_159
            - GENERIC_ACTION_16
            - GENERIC_ACTION_160
            - GENERIC_ACTION_161
            - GENERIC_ACTION_162
            - GENERIC_ACTION_163
            - GENERIC_ACTION_164
            - GENERIC_ACTION_165
            - GENERIC_ACTION_166
            - GENERIC_ACTION_167
            - GENERIC_ACTION_168
            - GENERIC_ACTION_169
            - GENERIC_ACTION_17
            - GENERIC_ACTION_170
            - GENERIC_ACTION_171
            - GENERIC_ACTION_172
            - GENERIC_ACTION_173
            - GENERIC_ACTION_174
            - GENERIC_ACTION_175
            - GENERIC_ACTION_176
            - GENERIC_ACTION_177
            - GENERIC_ACTION_178
            - GENERIC_ACTION_179
            - GENERIC_ACTION_18
            - GENERIC_ACTION_180
            - GENERIC_ACTION_181
            - GENERIC_ACTION_182
            - GENERIC_ACTION_183
            - GENERIC_ACTION_184
            - GENERIC_ACTION_185
            - GENERIC_ACTION_186
            - GENERIC_ACTION_187
            - GENERIC_ACTION_188
            - GENERIC_ACTION_189
            - GENERIC_ACTION_19
            - GENERIC_ACTION_190
            - GENERIC_ACTION_191
            - GENERIC_ACTION_192
            - GENERIC_ACTION_193
            - GENERIC_ACTION_194
            - GENERIC_ACTION_195
            - GENERIC_ACTION_196
            - GENERIC_ACTION_197
            - GENERIC_ACTION_198
            - GENERIC_ACTION_199
            - GENERIC_ACTION_2
            - GENERIC_ACTION_20
            - GENERIC_ACTION_200
            - GENERIC_ACTION_21
            - GENERIC_ACTION_22
            - GENERIC_ACTION_23
            - GENERIC_ACTION_24
            - GENERIC_ACTION_25
[...]
